#pragma once

// @generated by aten/src/ATen/gen.py

#include "ATen/CPUTypeDefault.h"
#include "ATen/Context.h"
#include "ATen/CheckGenerator.h"



#ifdef _MSC_VER
#ifdef Type
#undef Type
#endif
#endif

namespace at {

struct CPUCharType final : public CPUTypeDefault {
  explicit CPUCharType();
  virtual ScalarType scalarType() const override;
  virtual caffe2::TypeMeta typeMeta() const override;
  virtual Backend backend() const override;
  virtual const char * toString() const override;
  virtual size_t elementSizeInBytes() const override;
  virtual TypeID ID() const override;

  // example
  // virtual Tensor * add(Tensor & a, Tensor & b) override;

  virtual Tensor & s_copy_(Tensor & self, const Tensor & src, bool non_blocking) const override;
  virtual Tensor & _s_copy_from(const Tensor & self, Tensor & dst, bool non_blocking) const override;
  int64_t storage_offset(const Tensor & self) const override;
  Tensor & resize_(Tensor & self, IntList size) const override;
  Tensor & set_(Tensor & self, Storage source) const override;
  Tensor & set_(Tensor & self, Storage source, int64_t storage_offset, IntList size, IntList stride) const override;
  Tensor & set_(Tensor & self, const Tensor & source) const override;
  Tensor & set_(Tensor & self) const override;
  Tensor & _fill_(Tensor & self, Scalar value) const override;
  Tensor & _fill_(Tensor & self, const Tensor & value) const override;
  bool is_contiguous(const Tensor & self) const override;
  bool is_set_to(const Tensor & self, const Tensor & tensor) const override;
  Tensor & s_masked_fill_(Tensor & self, const Tensor & mask, Scalar value) const override;
  Tensor & s_masked_fill_(Tensor & self, const Tensor & mask, const Tensor & value) const override;
  Tensor & s_masked_scatter_(Tensor & self, const Tensor & mask, const Tensor & source) const override;
  Tensor & s_masked_select_out(Tensor & result, const Tensor & self, const Tensor & mask) const override;
  Tensor s_masked_select(const Tensor & self, const Tensor & mask) const override;
  Tensor & nonzero_out(Tensor & result, const Tensor & self) const override;
  Tensor nonzero(const Tensor & self) const override;
  Tensor contiguous(const Tensor & self) const override;
  Tensor th_clone(const Tensor & self) const override;
  Tensor view(const Tensor & self, IntList size) const override;
  Tensor & th_resize_as_(Tensor & self, const Tensor & the_template) const override;
  Tensor & index_select_out(Tensor & result, const Tensor & self, int64_t dim, const Tensor & index) const override;
  Tensor index_select(const Tensor & self, int64_t dim, const Tensor & index) const override;
  Tensor & _indexCopy_(Tensor & self, int64_t dim, const Tensor & index, const Tensor & source) const override;
  Tensor & take_out(Tensor & result, const Tensor & self, const Tensor & index) const override;
  Tensor take(const Tensor & self, const Tensor & index) const override;
  Tensor & put_(Tensor & self, const Tensor & index, const Tensor & source, bool accumulate) const override;
  Tensor & index_add_(Tensor & self, int64_t dim, const Tensor & index, const Tensor & source) const override;
  Tensor & index_fill_(Tensor & self, int64_t dim, const Tensor & index, Scalar value) const override;
  Tensor & index_fill_(Tensor & self, int64_t dim, const Tensor & index, const Tensor & value) const override;
  Tensor unfold(const Tensor & self, int64_t dimension, int64_t size, int64_t step) const override;
  Tensor & _range_out(Tensor & result, Scalar start, Scalar end, Scalar step) const override;
  Tensor _range(Scalar start, Scalar end, Scalar step) const override;
  Tensor & _arange_out(Tensor & result, Scalar start, Scalar end, Scalar step) const override;
  Tensor _arange(Scalar start, Scalar end, Scalar step) const override;
  Tensor & _arange_out(Tensor & result, Scalar end) const override;
  Tensor _arange(Scalar end) const override;
  Tensor & scatter_(Tensor & self, int64_t dim, const Tensor & index, const Tensor & src) const override;
  Tensor & scatter_(Tensor & self, int64_t dim, const Tensor & index, Scalar value) const override;
  Tensor & scatter_add_(Tensor & self, int64_t dim, const Tensor & index, const Tensor & src) const override;
  Tensor & gather_out(Tensor & result, const Tensor & self, int64_t dim, const Tensor & index) const override;
  Tensor gather(const Tensor & self, int64_t dim, const Tensor & index) const override;
  void* data_ptr(const Tensor & self) const override;
  bool equal(const Tensor & self, const Tensor & other) const override;
  Tensor & __and___out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor __and__(const Tensor & self, Scalar other) const override;
  Tensor & s___and___out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s___and__(const Tensor & self, const Tensor & other) const override;
  Tensor & __iand__(Tensor & self, Scalar other) const override;
  Tensor & s___iand__(Tensor & self, const Tensor & other) const override;
  Tensor & __or___out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor __or__(const Tensor & self, Scalar other) const override;
  Tensor & s___or___out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s___or__(const Tensor & self, const Tensor & other) const override;
  Tensor & __ior__(Tensor & self, Scalar other) const override;
  Tensor & s___ior__(Tensor & self, const Tensor & other) const override;
  Tensor & __xor___out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor __xor__(const Tensor & self, Scalar other) const override;
  Tensor & s___xor___out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s___xor__(const Tensor & self, const Tensor & other) const override;
  Tensor & __ixor__(Tensor & self, Scalar other) const override;
  Tensor & s___ixor__(Tensor & self, const Tensor & other) const override;
  Tensor & __lshift___out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor __lshift__(const Tensor & self, Scalar other) const override;
  Tensor & s___lshift___out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s___lshift__(const Tensor & self, const Tensor & other) const override;
  Tensor & __ilshift__(Tensor & self, Scalar other) const override;
  Tensor & s___ilshift__(Tensor & self, const Tensor & other) const override;
  Tensor & __rshift___out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor __rshift__(const Tensor & self, Scalar other) const override;
  Tensor & s___rshift___out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s___rshift__(const Tensor & self, const Tensor & other) const override;
  Tensor & __irshift__(Tensor & self, Scalar other) const override;
  Tensor & s___irshift__(Tensor & self, const Tensor & other) const override;
  Tensor & lt_out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor lt(const Tensor & self, Scalar other) const override;
  Tensor & s_lt_out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s_lt(const Tensor & self, const Tensor & other) const override;
  Tensor & lt_(Tensor & self, Scalar other) const override;
  Tensor & s_lt_(Tensor & self, const Tensor & other) const override;
  Tensor & gt_out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor gt(const Tensor & self, Scalar other) const override;
  Tensor & s_gt_out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s_gt(const Tensor & self, const Tensor & other) const override;
  Tensor & gt_(Tensor & self, Scalar other) const override;
  Tensor & s_gt_(Tensor & self, const Tensor & other) const override;
  Tensor & le_out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor le(const Tensor & self, Scalar other) const override;
  Tensor & s_le_out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s_le(const Tensor & self, const Tensor & other) const override;
  Tensor & le_(Tensor & self, Scalar other) const override;
  Tensor & s_le_(Tensor & self, const Tensor & other) const override;
  Tensor & ge_out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor ge(const Tensor & self, Scalar other) const override;
  Tensor & s_ge_out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s_ge(const Tensor & self, const Tensor & other) const override;
  Tensor & ge_(Tensor & self, Scalar other) const override;
  Tensor & s_ge_(Tensor & self, const Tensor & other) const override;
  Tensor & eq_out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor eq(const Tensor & self, Scalar other) const override;
  Tensor & s_eq_out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s_eq(const Tensor & self, const Tensor & other) const override;
  Tensor & eq_(Tensor & self, Scalar other) const override;
  Tensor & s_eq_(Tensor & self, const Tensor & other) const override;
  Tensor & ne_out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor ne(const Tensor & self, Scalar other) const override;
  Tensor & s_ne_out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s_ne(const Tensor & self, const Tensor & other) const override;
  Tensor & ne_(Tensor & self, Scalar other) const override;
  Tensor & s_ne_(Tensor & self, const Tensor & other) const override;
  Tensor & s_min_out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s_min(const Tensor & self, const Tensor & other) const override;
  Tensor min(const Tensor & self) const override;
  std::tuple<Tensor &,Tensor &> _th_min_out(Tensor & min, Tensor & min_indices, const Tensor & self, int64_t dim, bool keepdim) const override;
  std::tuple<Tensor,Tensor> _th_min(const Tensor & self, int64_t dim, bool keepdim) const override;
  Tensor & s_max_out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s_max(const Tensor & self, const Tensor & other) const override;
  Tensor max(const Tensor & self) const override;
  std::tuple<Tensor &,Tensor &> _th_max_out(Tensor & max, Tensor & max_indices, const Tensor & self, int64_t dim, bool keepdim) const override;
  std::tuple<Tensor,Tensor> _th_max(const Tensor & self, int64_t dim, bool keepdim) const override;
  std::tuple<Tensor &,Tensor &> _th_kthvalue_out(Tensor & values, Tensor & indices, const Tensor & self, int64_t k, int64_t dim, bool keepdim) const override;
  std::tuple<Tensor,Tensor> _th_kthvalue(const Tensor & self, int64_t k, int64_t dim, bool keepdim) const override;
  std::tuple<Tensor &,Tensor &> _th_mode_out(Tensor & values, Tensor & indices, const Tensor & self, int64_t dim, bool keepdim) const override;
  std::tuple<Tensor,Tensor> _th_mode(const Tensor & self, int64_t dim, bool keepdim) const override;
  Tensor median(const Tensor & self) const override;
  std::tuple<Tensor &,Tensor &> _th_median_out(Tensor & values, Tensor & indices, const Tensor & self, int64_t dim, bool keepdim) const override;
  std::tuple<Tensor,Tensor> _th_median(const Tensor & self, int64_t dim, bool keepdim) const override;
  std::tuple<Tensor &,Tensor &> sort_out(Tensor & values, Tensor & indices, const Tensor & self, int64_t dim, bool descending) const override;
  std::tuple<Tensor,Tensor> sort(const Tensor & self, int64_t dim, bool descending) const override;
  std::tuple<Tensor &,Tensor &> topk_out(Tensor & values, Tensor & indices, const Tensor & self, int64_t k, int64_t dim, bool largest, bool sorted) const override;
  std::tuple<Tensor,Tensor> topk(const Tensor & self, int64_t k, int64_t dim, bool largest, bool sorted) const override;
  Tensor & neg_out(Tensor & result, const Tensor & self) const override;
  Tensor neg(const Tensor & self) const override;
  Tensor & neg_(Tensor & self) const override;
  Tensor & th_pow_out(Tensor & result, const Tensor & self, Scalar exponent) const override;
  Tensor th_pow(const Tensor & self, Scalar exponent) const override;
  Tensor & s_pow_out(Tensor & result, const Tensor & self, const Tensor & exponent) const override;
  Tensor s_pow(const Tensor & self, const Tensor & exponent) const override;
  Tensor & pow_out(Tensor & result, Scalar base, const Tensor & self) const override;
  Tensor pow(Scalar base, const Tensor & self) const override;
  Tensor & pow_(Tensor & self, Scalar exponent) const override;
  Tensor & s_pow_(Tensor & self, const Tensor & exponent) const override;
  Tensor & th_zero_(Tensor & self) const override;
  Tensor _sumall(const Tensor & self) const override;
  Tensor & _th_sum_out(Tensor & result, const Tensor & self, int64_t dim, bool keepdim) const override;
  Tensor _th_sum(const Tensor & self, int64_t dim, bool keepdim) const override;
  Tensor _prodall(const Tensor & self) const override;
  Tensor & _th_prod_out(Tensor & result, const Tensor & self, int64_t dim, bool keepdim) const override;
  Tensor _th_prod(const Tensor & self, int64_t dim, bool keepdim) const override;
  Tensor & _cumsum_out(Tensor & result, const Tensor & self, int64_t dim) const override;
  Tensor _cumsum(const Tensor & self, int64_t dim) const override;
  Tensor & _cumprod_out(Tensor & result, const Tensor & self, int64_t dim) const override;
  Tensor _cumprod(const Tensor & self, int64_t dim) const override;
  Tensor & sign_out(Tensor & result, const Tensor & self) const override;
  Tensor sign(const Tensor & self) const override;
  Tensor & sign_(Tensor & self) const override;
  Tensor trace(const Tensor & self) const override;
  Tensor & fmod_out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor fmod(const Tensor & self, Scalar other) const override;
  Tensor & s_fmod_out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s_fmod(const Tensor & self, const Tensor & other) const override;
  Tensor & fmod_(Tensor & self, Scalar other) const override;
  Tensor & s_fmod_(Tensor & self, const Tensor & other) const override;
  Tensor & remainder_out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor remainder(const Tensor & self, Scalar other) const override;
  Tensor & s_remainder_out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor s_remainder(const Tensor & self, const Tensor & other) const override;
  Tensor & remainder_(Tensor & self, Scalar other) const override;
  Tensor & s_remainder_(Tensor & self, const Tensor & other) const override;
  Tensor & _th_clamp_out(Tensor & result, const Tensor & self, Scalar min, Scalar max) const override;
  Tensor _th_clamp(const Tensor & self, Scalar min, Scalar max) const override;
  Tensor & _th_clamp_min_out(Tensor & result, const Tensor & self, Scalar min) const override;
  Tensor _th_clamp_min(const Tensor & self, Scalar min) const override;
  Tensor & _th_clamp_max_out(Tensor & result, const Tensor & self, Scalar max) const override;
  Tensor _th_clamp_max(const Tensor & self, Scalar max) const override;
  Tensor _dot(const Tensor & self, const Tensor & tensor) const override;
  Tensor & tril_out(Tensor & result, const Tensor & self, int64_t diagonal) const override;
  Tensor tril(const Tensor & self, int64_t diagonal) const override;
  Tensor & tril_(Tensor & self, int64_t diagonal) const override;
  Tensor & triu_out(Tensor & result, const Tensor & self, int64_t diagonal) const override;
  Tensor triu(const Tensor & self, int64_t diagonal) const override;
  Tensor & triu_(Tensor & self, int64_t diagonal) const override;
  Tensor & cross_out(Tensor & result, const Tensor & self, const Tensor & other, int64_t dim) const override;
  Tensor cross(const Tensor & self, const Tensor & other, int64_t dim) const override;
  Tensor & diag_out(Tensor & result, const Tensor & self, int64_t diagonal) const override;
  Tensor diag(const Tensor & self, int64_t diagonal) const override;
  Tensor & s_th_addmm_out(Tensor & result, const Tensor & self, const Tensor & mat1, const Tensor & mat2, Scalar beta, Scalar alpha) const override;
  Tensor s_th_addmm(const Tensor & self, const Tensor & mat1, const Tensor & mat2, Scalar beta, Scalar alpha) const override;
  Tensor & th_addmm_(Tensor & self, const Tensor & mat1, const Tensor & mat2, Scalar beta, Scalar alpha) const override;
  Tensor & s__addmv_out(Tensor & result, const Tensor & self, const Tensor & mat, const Tensor & vec, Scalar beta, Scalar alpha) const override;
  Tensor s__addmv(const Tensor & self, const Tensor & mat, const Tensor & vec, Scalar beta, Scalar alpha) const override;
  Tensor & _addmv_(Tensor & self, const Tensor & mat, const Tensor & vec, Scalar beta, Scalar alpha) const override;
  Tensor & s__addr_out(Tensor & result, const Tensor & self, const Tensor & vec1, const Tensor & vec2, Scalar beta, Scalar alpha) const override;
  Tensor s__addr(const Tensor & self, const Tensor & vec1, const Tensor & vec2, Scalar beta, Scalar alpha) const override;
  Tensor & _addr_(Tensor & self, const Tensor & vec1, const Tensor & vec2, Scalar beta, Scalar alpha) const override;
  Tensor & _ger_out(Tensor & result, const Tensor & self, const Tensor & vec2) const override;
  Tensor _ger(const Tensor & self, const Tensor & vec2) const override;
  Tensor & _mv_out(Tensor & result, const Tensor & self, const Tensor & vec) const override;
  Tensor _mv(const Tensor & self, const Tensor & vec) const override;
  Tensor & _mm_out(Tensor & result, const Tensor & self, const Tensor & mat2) const override;
  Tensor _mm(const Tensor & self, const Tensor & mat2) const override;
  Tensor & s_addbmm_out(Tensor & result, const Tensor & self, const Tensor & batch1, const Tensor & batch2, Scalar beta, Scalar alpha) const override;
  Tensor s_addbmm(const Tensor & self, const Tensor & batch1, const Tensor & batch2, Scalar beta, Scalar alpha) const override;
  Tensor & addbmm_(Tensor & self, const Tensor & batch1, const Tensor & batch2, Scalar beta, Scalar alpha) const override;
  Tensor & s_addcmul_out(Tensor & result, const Tensor & self, const Tensor & tensor1, const Tensor & tensor2, Scalar value) const override;
  Tensor s_addcmul(const Tensor & self, const Tensor & tensor1, const Tensor & tensor2, Scalar value) const override;
  Tensor & s_addcmul_(Tensor & self, const Tensor & tensor1, const Tensor & tensor2, Scalar value) const override;
  Tensor & s_addcdiv_out(Tensor & result, const Tensor & self, const Tensor & tensor1, const Tensor & tensor2, Scalar value) const override;
  Tensor s_addcdiv(const Tensor & self, const Tensor & tensor1, const Tensor & tensor2, Scalar value) const override;
  Tensor & s_addcdiv_(Tensor & self, const Tensor & tensor1, const Tensor & tensor2, Scalar value) const override;
  Tensor & random_(Tensor & self, int64_t from, int64_t to, Generator * generator) const override;
  Tensor & random_(Tensor & self, int64_t to, Generator * generator) const override;
  Tensor & random_(Tensor & self, Generator * generator) const override;
  Tensor & geometric_(Tensor & self, double p, Generator * generator) const override;
  Tensor th_tensor(IntList size) const override;
  Tensor th_tensor() const override;
  Tensor tensor(Storage storage, int64_t storageOffset, IntList size, IntList stride) const override;
  Tensor tensor(IntList size, IntList stride) const override;
  Tensor alias(const Tensor & self) const override;
  Tensor & _cat_out(Tensor & self, TensorList tensors, int64_t dim) const override;
  Tensor _cat(TensorList tensors, int64_t dim) const override;
  std::tuple<Tensor,Tensor> _cudnn_ctc_loss(const Tensor & log_probs, const Tensor & targets, IntList input_lengths, IntList target_lengths, int64_t blank, bool deterministic) const override;
  Tensor _cudnn_rnn_flatten_weight(TensorList weight_arr, int64_t weight_stride0, int64_t input_size, int64_t mode, int64_t hidden_size, int64_t num_layers, bool batch_first, bool bidirectional) const override;
  std::tuple<Tensor,Tensor,Tensor,Tensor,Tensor> _cudnn_rnn(const Tensor & input, TensorList weight, int64_t weight_stride0, const Tensor & weight_buf, const Tensor & hx, const Tensor & cx, int64_t mode, int64_t hidden_size, int64_t num_layers, bool batch_first, double dropout, bool train, bool bidirectional, IntList batch_sizes, const Tensor & dropout_state) const override;
  std::tuple<Tensor,Tensor,Tensor,std::vector<Tensor>> _cudnn_rnn_backward(const Tensor & input, TensorList weight, int64_t weight_stride0, const Tensor & weight_buf, const Tensor & hx, const Tensor & cx, const Tensor & output, const Tensor & grad_output, const Tensor & grad_hy, const Tensor & grad_cy, int64_t mode, int64_t hidden_size, int64_t num_layers, bool batch_first, double dropout, bool train, bool bidirectional, IntList batch_sizes, const Tensor & dropout_state, const Tensor & reserve, std::array<bool,4> output_mask) const override;
  Tensor _cudnn_init_dropout_state(double dropout, bool train, int64_t dropout_seed) const override;
  std::tuple<Tensor,Tensor> _fused_dropout(const Tensor & self, double p, Generator * generator) const override;
  Tensor _masked_scale(const Tensor & self, const Tensor & mask, double scale) const override;
  Tensor & abs_(Tensor & self) const override;
  Tensor & abs_out(Tensor & result, const Tensor & self) const override;
  Tensor & acos_(Tensor & self) const override;
  Tensor & acos_out(Tensor & result, const Tensor & self) const override;
  Tensor & asin_(Tensor & self) const override;
  Tensor & asin_out(Tensor & result, const Tensor & self) const override;
  Tensor & atan_(Tensor & self) const override;
  Tensor & atan_out(Tensor & result, const Tensor & self) const override;
  Tensor baddbmm(const Tensor & self, const Tensor & batch1, const Tensor & batch2, Scalar beta, Scalar alpha) const override;
  Tensor & baddbmm_(Tensor & self, const Tensor & batch1, const Tensor & batch2, Scalar beta, Scalar alpha) const override;
  Tensor & baddbmm_out(Tensor & result, const Tensor & self, const Tensor & batch1, const Tensor & batch2, Scalar beta, Scalar alpha) const override;
  Tensor & bernoulli_(Tensor & self, const Tensor & p, Generator * generator) const override;
  Tensor & bernoulli_(Tensor & self, double p, Generator * generator) const override;
  Tensor bincount(const Tensor & self, const Tensor & weights, int64_t minlength) const override;
  Tensor bmm(const Tensor & self, const Tensor & mat2) const override;
  Tensor & bmm_out(Tensor & result, const Tensor & self, const Tensor & mat2) const override;
  Tensor & ceil_(Tensor & self) const override;
  Tensor & ceil_out(Tensor & result, const Tensor & self) const override;
  Tensor & clamp_(Tensor & self, Scalar min, Scalar max) const override;
  Tensor & clamp_out(Tensor & result, const Tensor & self, Scalar min, Scalar max) const override;
  Tensor & clamp_max_(Tensor & self, Scalar max) const override;
  Tensor & clamp_max_out(Tensor & result, const Tensor & self, Scalar max) const override;
  Tensor & clamp_min_(Tensor & self, Scalar min) const override;
  Tensor & clamp_min_out(Tensor & result, const Tensor & self, Scalar min) const override;
  Tensor & cos_(Tensor & self) const override;
  Tensor & cos_out(Tensor & result, const Tensor & self) const override;
  Tensor & cosh_(Tensor & self) const override;
  Tensor & cosh_out(Tensor & result, const Tensor & self) const override;
  Tensor cudnn_affine_grid_generator(const Tensor & theta, int64_t N, int64_t C, int64_t H, int64_t W) const override;
  Tensor cudnn_affine_grid_generator_backward(const Tensor & grad, int64_t N, int64_t C, int64_t H, int64_t W) const override;
  std::tuple<Tensor,Tensor,Tensor> cudnn_batch_norm(const Tensor & input, const Tensor & weight, const Tensor & bias, const Tensor & running_mean, const Tensor & running_var, bool training, double exponential_average_factor, double epsilon) const override;
  std::tuple<Tensor,Tensor,Tensor> cudnn_batch_norm_backward(const Tensor & input, const Tensor & grad_output, const Tensor & weight, const Tensor & running_mean, const Tensor & running_var, const Tensor & save_mean, const Tensor & save_var, double epsilon) const override;
  Tensor cudnn_convolution(const Tensor & self, const Tensor & weight, const Tensor & bias, IntList padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic) const override;
  Tensor cudnn_convolution_backward_input(IntList self_size, const Tensor & grad_output, const Tensor & weight, IntList padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic) const override;
  std::tuple<Tensor,Tensor,Tensor> cudnn_convolution_backward(const Tensor & self, const Tensor & grad_output, const Tensor & weight, IntList padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic, std::array<bool,3> output_mask) const override;
  Tensor cudnn_convolution_backward_bias(const Tensor & grad_output) const override;
  Tensor cudnn_convolution_backward_weight(IntList weight_size, const Tensor & grad_output, const Tensor & self, IntList padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic) const override;
  Tensor cudnn_convolution_transpose(const Tensor & self, const Tensor & weight, const Tensor & bias, IntList padding, IntList output_padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic) const override;
  std::tuple<Tensor,Tensor,Tensor> cudnn_convolution_transpose_backward(const Tensor & self, const Tensor & grad_output, const Tensor & weight, IntList padding, IntList output_padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic, std::array<bool,3> output_mask) const override;
  Tensor cudnn_convolution_transpose_backward_bias(const Tensor & grad_output) const override;
  Tensor cudnn_convolution_transpose_backward_input(const Tensor & grad_output, const Tensor & weight, IntList padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic) const override;
  Tensor cudnn_convolution_transpose_backward_weight(IntList weight_size, const Tensor & grad_output, const Tensor & self, IntList padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic) const override;
  Tensor cudnn_grid_sampler(const Tensor & self, const Tensor & grid) const override;
  std::tuple<Tensor,Tensor> cudnn_grid_sampler_backward(const Tensor & self, const Tensor & grid, const Tensor & grad_output) const override;
  std::tuple<Tensor,Tensor> _ctc_loss(const Tensor & log_probs, const Tensor & targets, IntList input_lengths, IntList target_lengths, int64_t blank) const override;
  Tensor _ctc_loss_backward(const Tensor & grad, const Tensor & log_probs, const Tensor & targets, IntList input_lengths, IntList target_lengths, const Tensor & neg_log_likelihood, const Tensor & log_alpha, int64_t blank) const override;
  Tensor embedding_dense_backward(const Tensor & grad, const Tensor & indices, int64_t num_weights, int64_t padding_idx, bool scale_grad_by_freq) const override;
  Tensor & embedding_renorm_(Tensor & self, const Tensor & indices, double max_norm, double norm_type) const override;
  std::tuple<Tensor,Tensor,Tensor,Tensor> _embedding_bag(const Tensor & weight, const Tensor & indices, const Tensor & offsets, bool scale_grad_by_freq, int64_t mode, bool sparse) const override;
  Tensor _embedding_bag_dense_backward(const Tensor & grad, const Tensor & indices, const Tensor & offsets, const Tensor & offset2bag, const Tensor & bag_size, const Tensor & maximum_indices, int64_t num_weights, bool scale_grad_by_freq, int64_t mode) const override;
  Tensor & erf_(Tensor & self) const override;
  Tensor & erf_out(Tensor & result, const Tensor & self) const override;
  Tensor & erfc_(Tensor & self) const override;
  Tensor & erfc_out(Tensor & result, const Tensor & self) const override;
  Tensor & exp_(Tensor & self) const override;
  Tensor & exp_out(Tensor & result, const Tensor & self) const override;
  Tensor & expm1_(Tensor & self) const override;
  Tensor & expm1_out(Tensor & result, const Tensor & self) const override;
  Tensor & eye_out(Tensor & result, int64_t n) const override;
  Tensor & eye_out(Tensor & result, int64_t n, int64_t m) const override;
  Tensor & floor_(Tensor & self) const override;
  Tensor & floor_out(Tensor & result, const Tensor & self) const override;
  Tensor grid_sampler_2d(const Tensor & input, const Tensor & grid, int64_t interpolation_mode, int64_t padding_mode) const override;
  std::tuple<Tensor,Tensor> grid_sampler_2d_backward(const Tensor & grad_output, const Tensor & input, const Tensor & grid, int64_t interpolation_mode, int64_t padding_mode) const override;
  Tensor grid_sampler_3d(const Tensor & input, const Tensor & grid, int64_t interpolation_mode, int64_t padding_mode) const override;
  std::tuple<Tensor,Tensor> grid_sampler_3d_backward(const Tensor & grad_output, const Tensor & input, const Tensor & grid, int64_t interpolation_mode, int64_t padding_mode) const override;
  std::tuple<Tensor,Tensor> _gesv_helper(const Tensor & self, const Tensor & A) const override;
  Tensor _fft_with_size(const Tensor & self, int64_t signal_ndim, bool complex_input, bool complex_output, bool inverse, IntList checked_signal_sizes, bool normalized, bool onesided, IntList output_sizes) const override;
  Tensor kl_div_backward(const Tensor & grad_output, const Tensor & self, const Tensor & target, int64_t reduction) const override;
  Tensor & log_(Tensor & self) const override;
  Tensor & log_out(Tensor & result, const Tensor & self) const override;
  Tensor & log10_(Tensor & self) const override;
  Tensor & log10_out(Tensor & result, const Tensor & self) const override;
  Tensor & log1p_(Tensor & self) const override;
  Tensor & log1p_out(Tensor & result, const Tensor & self) const override;
  Tensor & log2_(Tensor & self) const override;
  Tensor & log2_out(Tensor & result, const Tensor & self) const override;
  Tensor log_softmax(const Tensor & self, int64_t dim) const override;
  Tensor log_softmax_backward_data(const Tensor & grad_output, const Tensor & output, int64_t dim, const Tensor & self) const override;
  std::tuple<Tensor,Tensor,Tensor> miopen_batch_norm(const Tensor & input, const Tensor & weight, const Tensor & bias, const Tensor & running_mean, const Tensor & running_var, bool training, double exponential_average_factor, double epsilon) const override;
  std::tuple<Tensor,Tensor,Tensor> miopen_batch_norm_backward(const Tensor & input, const Tensor & grad_output, const Tensor & weight, const Tensor & running_mean, const Tensor & running_var, const Tensor & save_mean, const Tensor & save_var, double epsilon) const override;
  Tensor miopen_convolution(const Tensor & self, const Tensor & weight, const Tensor & bias, IntList padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic) const override;
  Tensor miopen_convolution_backward_input(IntList self_size, const Tensor & grad_output, const Tensor & weight, IntList padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic) const override;
  std::tuple<Tensor,Tensor,Tensor> miopen_convolution_backward(const Tensor & self, const Tensor & grad_output, const Tensor & weight, IntList padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic, std::array<bool,3> output_mask) const override;
  Tensor miopen_convolution_backward_bias(const Tensor & grad_output) const override;
  Tensor miopen_convolution_backward_weight(IntList weight_size, const Tensor & grad_output, const Tensor & self, IntList padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic) const override;
  Tensor miopen_convolution_transpose(const Tensor & self, const Tensor & weight, const Tensor & bias, IntList padding, IntList output_padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic) const override;
  std::tuple<Tensor,Tensor,Tensor> miopen_convolution_transpose_backward(const Tensor & self, const Tensor & grad_output, const Tensor & weight, IntList padding, IntList output_padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic, std::array<bool,3> output_mask) const override;
  Tensor miopen_convolution_transpose_backward_input(const Tensor & grad_output, const Tensor & weight, IntList padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic) const override;
  Tensor miopen_convolution_transpose_backward_weight(IntList weight_size, const Tensor & grad_output, const Tensor & self, IntList padding, IntList stride, IntList dilation, int64_t groups, bool benchmark, bool deterministic) const override;
  Tensor narrow_copy(const Tensor & self, int64_t dim, int64_t start, int64_t length) const override;
  Tensor & randperm_out(Tensor & result, int64_t n, Generator * generator) const override;
  std::tuple<Tensor,Tensor> RoiPooling2d_forward(const Tensor & input, const Tensor & rois, int64_t pooledHeight, int64_t pooledWidth, double spatialScale) const override;
  Tensor RoiPooling2d_backward(const Tensor & input, const Tensor & rois, int64_t pooledHeight, int64_t pooledWidth, double spatialScale, const Tensor & gradOutput, const Tensor & argmaxes) const override;
  Tensor & round_(Tensor & self) const override;
  Tensor & round_out(Tensor & result, const Tensor & self) const override;
  Tensor prelu(const Tensor & self, const Tensor & weight) const override;
  std::tuple<Tensor,Tensor> prelu_backward(const Tensor & grad_output, const Tensor & self, const Tensor & weight) const override;
  Tensor hardshrink(const Tensor & self, Scalar lambd) const override;
  Tensor hardshrink_backward(const Tensor & grad_out, const Tensor & self, Scalar lambd) const override;
  Tensor & rsqrt_(Tensor & self) const override;
  Tensor & rsqrt_out(Tensor & result, const Tensor & self) const override;
  Tensor & sigmoid_(Tensor & self) const override;
  Tensor & sigmoid_out(Tensor & result, const Tensor & self) const override;
  Tensor & sin_(Tensor & self) const override;
  Tensor & sin_out(Tensor & result, const Tensor & self) const override;
  Tensor & sinh_(Tensor & self) const override;
  Tensor & sinh_out(Tensor & result, const Tensor & self) const override;
  Tensor softmax(const Tensor & self, int64_t dim) const override;
  Tensor softmax_backward_data(const Tensor & grad_output, const Tensor & output, int64_t dim, const Tensor & self) const override;
  Tensor & _sparse_add_out(Tensor & result, const Tensor & self, const Tensor & other, Scalar alpha) const override;
  Tensor & _sparse_dense_add_out(Tensor & result, const Tensor & self, SparseTensorRef other, Scalar alpha) const override;
  Tensor & _sparse_div_zerodim_out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor & _sparse_div_scalar_out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor & _sparse_mul_out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor & _sparse_mul_zerodim_out(Tensor & result, const Tensor & self, const Tensor & other) const override;
  Tensor & _sparse_mul_scalar_out(Tensor & result, const Tensor & self, Scalar other) const override;
  Tensor & sspaddmm_out(Tensor & result, const Tensor & self, const Tensor & mat1, const Tensor & mat2, Scalar beta, Scalar alpha) const override;
  Tensor _sum(const Tensor & self) const override;
  Tensor & _sum_cuda_out(Tensor & result, const Tensor & self, int64_t dim, bool keepdim) const override;
  Tensor & sqrt_(Tensor & self) const override;
  Tensor & sqrt_out(Tensor & result, const Tensor & self) const override;
  Tensor _prod(const Tensor & self) const override;
  Tensor & _prod_out(Tensor & result, const Tensor & self, int64_t dim, bool keepdim) const override;
  Tensor & tan_(Tensor & self) const override;
  Tensor & tan_out(Tensor & result, const Tensor & self) const override;
  Tensor & tanh_(Tensor & self) const override;
  Tensor & tanh_out(Tensor & result, const Tensor & self) const override;
  Tensor flip(const Tensor & self, IntList dims) const override;
  Tensor & trunc_(Tensor & self) const override;
  Tensor & trunc_out(Tensor & result, const Tensor & self) const override;
  std::tuple<Tensor,Tensor> _unique(const Tensor & self, bool sorted, bool return_inverse) const override;
  std::tuple<Tensor,Tensor> _unique_dim(const Tensor & self, int64_t dim, bool sorted, bool return_inverse) const override;
  Tensor _s_where(const Tensor & condition, const Tensor & self, const Tensor & other) const override;
  std::tuple<Tensor,Tensor> _weight_norm_cuda_interface(const Tensor & v, const Tensor & g, int64_t dim) const override;
  std::tuple<Tensor,Tensor> _weight_norm_cuda_interface_backward(const Tensor & grad_w, const Tensor & saved_v, const Tensor & saved_g, const Tensor & saved_norms, int64_t dim) const override;
  Tensor _standard_gamma_grad(const Tensor & self, const Tensor & output) const override;
  Tensor _standard_gamma(const Tensor & self, Generator * generator) const override;
  Tensor poisson(const Tensor & self, Generator * generator) const override;
  Tensor native_norm(const Tensor & self, Scalar p) const override;
  Tensor native_clone(const Tensor & self) const override;
  Tensor & native_resize_as_(Tensor & self, const Tensor & the_template) const override;
  Tensor & native_pow_out(Tensor & result, const Tensor & self, Scalar exponent) const override;
  Tensor native_pow(const Tensor & self, Scalar exponent) const override;
  Tensor & native_zero_(Tensor & self) const override;
  Tensor & s_native_addmm_out(Tensor & result, const Tensor & self, const Tensor & mat1, const Tensor & mat2, Scalar beta, Scalar alpha) const override;
  Tensor s_native_addmm(const Tensor & self, const Tensor & mat1, const Tensor & mat2, Scalar beta, Scalar alpha) const override;
  Tensor & s_native_addmm_(Tensor & self, const Tensor & mat1, const Tensor & mat2, Scalar beta, Scalar alpha) const override;
  Tensor native_tensor() const override;
  Tensor native_tensor(IntList size) const override;
  Tensor native_sparse_coo_tensor(IntList size) const override;
  Tensor native_sparse_coo_tensor(const Tensor & indices, const Tensor & values) const override;
  Tensor native_sparse_coo_tensor(const Tensor & indices, const Tensor & values, IntList size) const override;
  Tensor _native_sparse_coo_tensor_unsafe(const Tensor & indices, const Tensor & values, IntList size) const override;
  Tensor & sparse_resize_(Tensor & self, IntList size, int64_t sparseDims, int64_t denseDims) const override;
  Tensor & sparse_resize_and_clear_(Tensor & self, IntList size, int64_t sparseDims, int64_t denseDims) const override;
  Tensor sparse_mask(const Tensor & self, SparseTensorRef mask) const override;
  Tensor to_dense(const Tensor & self) const override;
  int64_t _sparseDims(const Tensor & self) const override;
  int64_t _denseDims(const Tensor & self) const override;
  int64_t _nnz(const Tensor & self) const override;
  Tensor coalesce(const Tensor & self) const override;
  bool is_coalesced(const Tensor & self) const override;
  Tensor _indices(const Tensor & self) const override;
  Tensor _values(const Tensor & self) const override;
  Tensor & hspmm_out(Tensor & result, const Tensor & mat1, const Tensor & mat2) const override;
  Tensor hspmm(const Tensor & mat1, const Tensor & mat2) const override;
  Tensor & copy_sparse_to_sparse_(Tensor & self, const Tensor & src, bool non_blocking) const override;
  int64_t native_get_device(const Tensor & self) const override;
  Scalar _local_scalar_dense(const Tensor & self) const override;
  std::tuple<Tensor,Tensor,Tensor> _thnn_fused_lstm_cell(const Tensor & input_gates, const Tensor & hidden_gates, const Tensor & cx, const Tensor & input_bias, const Tensor & hidden_bias) const override;
  std::tuple<Tensor,Tensor,Tensor,Tensor,Tensor> _thnn_fused_lstm_cell_backward(const Tensor & grad_hy, const Tensor & grad_cy, const Tensor & cx, const Tensor & cy, const Tensor & workspace, bool has_bias) const override;
  std::tuple<Tensor,Tensor> _thnn_fused_gru_cell(const Tensor & input_gates, const Tensor & hidden_gates, const Tensor & hx, const Tensor & input_bias, const Tensor & hidden_bias) const override;
  std::tuple<Tensor,Tensor,Tensor,Tensor,Tensor> _thnn_fused_gru_cell_backward(const Tensor & grad_hy, const Tensor & workspace, bool has_bias) const override;
};

} // namespace at
